#include <windows.h>
#include <math.h>
#include <stdio.h>

static char FPU[1000];

#define M_PI 3.14159265358979323846

class PT
{
 public:
 double x;
 double y;
 friend PT operator+(PT A,PT B);
 friend PT operator-(PT A,PT B);
 friend PT operator/(PT A,double B);
 friend PT operator*(PT A,double B);
 friend double mod(PT A);
};

double mod(PT A)
{
  return sqrt(A.x*A.x+A.y*A.y);
}

PT operator+(PT A,PT B)
{
  PT C;
  C.x=A.x+B.x;
  C.y=A.y+B.y;
  return C;
}

PT operator-(PT A,PT B)
{
  PT C;
  C.x=A.x-B.x;
  C.y=A.y-B.y;
  return C;
}

PT operator/(PT A,double B)
{
  PT C;
  C.x=A.x/B;
  C.y=A.y/B;
  return C;
}

PT operator*(PT A,double B)
{
  PT C;
  C.x=A.x*B;
  C.y=A.y*B;
  return C;
}

typedef struct
{
  HWND hwnd;
  int PointNum;
  PT *Point;
  PT B;
  int x_0,y_0;
  PT Step,Len,Min,Max;
  int *GraphPos;
}GRPH;

typedef PT (*FN_)(PT Point, double fi);

LRESULT FAR PASCAL WndProc(HWND hwnd,UINT message,UINT wParam,LONG lParam);
HINSTANCE hInst;
LRESULT MsgPaint(HWND hwnd, HDC hdc);
void DrawGDIOutput(HWND hwnd, HDC hdc);
int MsgMouseMove(int fwKeys, int xPos, int yPos);
double psi(double fi);
double ksi(double fi);
double my(double fi);
double Xa(PT Point, double fi);
double Ya(PT Point, double fi);
double Xb(PT Point, double fi);
double Yb(PT Point, double fi);
double Xk(PT Point, double fi);
double Yk(PT Point, double fi);
double leng(PT P1, PT P2);
double high(PT P1, PT P2, PT Pt);
PT Z1(PT Point, double fi);
PT Z2(PT Point, double fi);
PT Z3(PT Point, double fi);
PT Z4(PT Point, double fi);
PT Z5(PT Point, double fi);
PT Z1_t(PT Point, double fi);
PT Z2_t(PT Point, double fi);
PT Z3_t(PT Point, double fi);
PT Z4_t(PT Point, double fi);
PT Z5_t(PT Point, double fi);
PT Z1_tt(PT Point, double fi);
PT Z2_tt(PT Point, double fi);
PT Z3_tt(PT Point, double fi);
PT Z4_tt(PT Point, double fi);
PT Z5_tt(PT Point, double fi);
PT Z1_E(PT Point, double fi);
PT Z2_E(PT Point, double fi);
PT Z3_E(PT Point, double fi);
PT Z4_E(PT Point, double fi);
PT Z5_E(PT Point, double fi);
PT P_O(PT Point, double fi);
PT P_A(PT Point, double fi);
PT P_B(PT Point, double fi);
PT P_D(PT Point, double fi);
PT P_K(PT Point, double fi);
void MsgContextMenu(HWND hwnd, WORD xPos, WORD yPos);
void SaveStat();
void RestoreStat();
void PSet(HDC hdc, PT Point, COLORREF crColor);
HPEN Line(HDC hdc, PT Point1, PT Point2, HPEN Pen);
void LineZ(HDC hdc, PT Point1, PT Point2, int Num);
double fi_t(double fi);
double fi_tt(double fi);
double psi_t(double fi);
double psi_tt(double fi);
double ksi_t(double fi);
double ksi_tt(double fi);
double my_t(double fi);
double my_tt(double fi);
void CircleF(HDC hdc, PT Point, double r);
void Circle(HDC hdc, PT Point, double r);
void Sharnir(HDC hdc, PT Point, int Num);
void Polzun(HDC hdc, PT Point, double fi, int Num);
PT Turn(PT Polus, PT Point, double fi);
void Cross(HDC hdc, PT Point, HPEN Pen);
void Vektor(HDC hdc, PT Polus, PT Point, HPEN Pen);
void Vektor_v(HDC hdc, PT Polus, PT Point, HPEN Pen);
double Angle(PT Point, PT Polus);
PT Norm(PT Pt);
LONG ExceptionFilter(EXCEPTION_POINTERS *ExceptionInfo);
PT F_b(PT Point, double fi);
PT F_k(PT Point, double fi);
PT F_d(PT Point, double fi);
PT F_a(PT Point, double fi);
void Free();
void Fill();
LRESULT FAR PASCAL Graph(HWND hwnd,UINT message,UINT wParam,LONG lParam);
LRESULT MsgGraphPaint(HWND hwnd, HDC hdc, GRPH *GraphWindow);
void DrawGraph(HWND hwnd, HDC hdc, GRPH *GraphWindow);
void Grid(HDC hdc);
MsgCommand(int ID);
void Energy(HDC hdc, PT Polus, PT Point, HPEN Pen);
void Text(HDC hdc, PT Polus, COLORREF Color, UINT Allign, char *str);

int ShowV=1,ShowA=1,ShowF=-1,ShowE=-1,ShowP=-1;
int GraphPos[3]={0,0,0};
int WinSizeX,WinSizeY;
PT a,b,d,k,o={0,0},o1={53,-8},o1_p,MC[9],ptNULL={0xffffffff,0xffffffff},mm,mm_p;
PT *A,*B,*D,*K,*A_t,*B_t,*D_t,*K_t,*A_tt,*B_tt,*D_tt,*K_tt;
int PNum,FilledFlag=-1;
double Step;
PT BB,Bmain,Bv={1,1};
PT Len,Min,Max;
int X2Scr(double x);
int Y2Scr(double y);

int ShiftState,FirstStartFl=1;
int GraphWindowNum=20;
GRPH *GraphWindow;

int fl=0,xStart,yStart,xEnd,yEnd,Select=0,Error1=0,Error=0,MC_changed=0;
int xmax,ymax;
int x_0,y_0;
int StatusSaved=0;

HPEN Red,Green,Blue,Black,Green0;
HDC qhdc,MemHdc;
HBITMAP Bitmap;


double  fi0=M_PI*55.0/180.0,fi0_t=1,
        beta=M_PI*0/180.0,beta_p,
        teta,fi,fi_p,m=-150,m_p,delta=0,delta_p=0;
double  L[9],L_p[9],M[9],J[9];
HWND MainWin;

#include "Dialog.cpp"
#include "StrtParm.cpp"
#include "Help.cpp"

double leng(PT P1, PT P2)
{
  return sqrt((P2.x-P1.x)*(P2.x-P1.x)+(P2.y-P1.y)*(P2.y-P1.y));
}

double high(PT P1, PT P2, PT Pt)
{
   double l1,l2,l3;

   l1=leng(P1,P2);
   l2=leng(P1,Pt);
   l3=leng(Pt,P2);
   return l2*sin(acos((l2*l2+l1*l1-l3*l3)/(2*l1*l2)));
}

double high1(PT Pt)
{
  double l1,l2,tm1,tm2;

  l1=abs(Pt.y-m-Pt.x*tan(beta));
  l2=abs(Pt.x-(Pt.y-m)/tan(beta));
  tm1=l2/l1;
  tm2=atan(tm1);
  return l1*sin(tm2);
}

int GetObject(PT Pt)
{
  double h,h1;
  int n=1;
  PT P1,P2,P3,P4;

  P1=Z1(a,fi0);
  P2=Z2(b,fi0);
  P3=Z2(d,fi0);
  P4=Z4(k,fi0);
  h=high(o,P1,Pt);
  h1=high(P1,P2,Pt);
  if(h1<h)
  {
    n=2;
    h=h1;
  }
  h1=high(P2,o1,Pt);
  if(h1<h)
  {
    n=3;
    h=h1;
  }
  h1=high(P1,P3,Pt);
  if(h1<h)
  {
    n=4;
    h=h1;
  }
  h1=high(P2,P3,Pt);
  if(h1<h)
  {
    n=5;
    h=h1;
  }
  h1=high(P3,P4,Pt);
  if(h1<h)
  {
    n=6;
    h=h1;
  }
  h1=high1(Pt);
  if(h1<h)
  {
    n=7;
//    h=h1;
  }
  return n;
}

#pragma argsused
double fi_t(double fi)
{
/*
  double fit=fi0_t,fi1,dfi=0.001;

  if(fi>fi0)
    for(fi1=fi0;fi1<fi;fi1+=dfi)
       fit+=fi_tt(fi)*dfi/fit;
  else
    for(fi1=fi0;fi1>fi;fi1-=dfi)
       fit+=fi_tt(fi)*dfi/fit;
  return fit;
*/
  return 1;
}

#pragma argsused
double fi_tt(double fi)
{
  return 0;
}

double psi(double fi)
{
  double tmp;

  tmp=(mm.y-L[1]*sin(fi))/L[2];
  if(tmp>1 || tmp<-1)
  {
    Error=1;
    return 0;
  }
  return asin(tmp);
}

double psi_t(double fi)
{
  double tmp=L[2]*cos(psi(fi));
  return -fi_t(fi)*L[1]*cos(fi)/tmp;
}

double psi_tt(double fi)
{
  return -fi_tt(fi)*L[1]*cos(fi)/(L[2]*cos(psi(fi)))+fi_t(fi)*fi_t(fi)*L[1]/L[2]*(sin(fi)/cos(psi(fi))+L[1]*cos(fi)*cos(fi)/(L[2]*cos(psi(fi))*cos(psi(fi)))*tan(psi(fi)));
}

double sign(double fi)
{
  double sg;

//  if(fi==0)
//    sg=0;
  if(fi<0)
    sg=-1;
  if(fi>=0)
    sg=1;
  return sg;
}

double ksi(double fi)
{
  double tmp=L[1]*sin(fi)-L[2]*sin(-psi(fi))-o1.y;
  double tmp1=(L[2]*cos(psi(fi))+L[1]*cos(fi)-o1.x)/L[3];
  if(abs(tmp1)>1-0.000000001)
  {
    Error=1;
    return 0;
  }
  return acos(tmp1)*sign(tmp);
}

double ksi_t(double fi)
{
  double tmp=L[3]*sin(psi(fi)-ksi(fi));
  if(abs(tmp)<0.0000001)
    tmp=0.0000001;
  return -fi_t(fi)*L[1]*sin(fi-psi(fi))/tmp;
}

double ksi_tt(double fi)
{
  double f1,f2;

  f1=fi_tt(fi)*L[1]*sin(fi)+fi_t(fi)*fi_t(fi)*L[1]*cos(fi)+psi_t(fi)*psi_t(fi)*L[2]*cos(psi(fi))-ksi_t(fi)*ksi_t(fi)*L[3]*cos(ksi(fi));
  f2=-fi_tt(fi)*L[1]*cos(fi)+fi_t(fi)*fi_t(fi)*L[1]*sin(fi)+psi_t(fi)*psi_t(fi)*L[2]*sin(psi(fi))-ksi_t(fi)*ksi_t(fi)*L[3]*sin(ksi(fi));

  double tmp=L[3]*sin(ksi(fi)-psi(fi));
  if(abs(tmp)<0.0000001)
    tmp=0.0000001;
  return (f1*cos(psi(fi))+f2*sin(psi(fi)))/tmp;
}

double my(double fi)
{
  double Xm,Ym,H,Xd,Yd,tmp1,tmp;
  Xd=Xb(d,fi);
  Yd=Yb(d,fi);

  Xm=(Xd+(Yd-m)*tan(beta))/(1+tan(beta)*tan(beta));
  Ym=(m+Xd*tan(beta)+Yd*tan(beta)*tan(beta))/(1+tan(beta)*tan(beta));
  tmp=(Xm-Xd)*(Xm-Xd)+(Ym-Yd)*(Ym-Yd);
  if(tmp<0)
  {
    Error=1;
    return 0;
  }
  H=sqrt(tmp)*sign((Xm-Xd)*beta);
  tmp1=H/L[6];
  if(abs(tmp1)>1-0.000000001)
  {
    Error=1;
    return 0;
  }
  return beta+asin(tmp1);
}

double my_t(double fi)
{
  double d_fi;
  d_fi=0.000001;
  return (my(fi+d_fi)-my(fi))/d_fi*fi_t(fi);
}

double my_tt(double fi)
{
  double d_fi;
  d_fi=0.000001;
  return (my_t(fi+d_fi)-my_t(fi))/d_fi*fi_t(fi);
}

# define alpha_A L[1]*cos(fi0)
# define beta_A  L[1]*sin(fi0)

PT Z1(PT Point, double fi)
{
  PT P1;

  P1.x=Xa(Point, fi);
  P1.y=Ya(Point, fi);
  return P1;
}

PT Z1_t(PT Point, double fi)
{
  PT P1,Pn;

  Pn=Z1(Point,fi);
  P1.x=-fi_t(fi)*Pn.y;
  P1.y=fi_t(fi)*Pn.x;
  return P1;
}

PT Z1_tt(PT Point, double fi)
{
  PT P1,Pn,Pn_t;

  Pn=Z1(Point,fi);
  Pn_t=Z1_t(Point,fi);

  P1.x=-fi_t(fi)*Pn_t.y-fi_tt(fi)*Pn.y;
  P1.y=fi_t(fi)*Pn_t.x+fi_tt(fi)*Pn.x;
  return Norm(P1);
}

#pragma argsused
PT Z1_E(PT Point, double fi)
{
  PT P1;
  double fit;

  fit=fi_t(fi);
  P1=Z1_t(MC[1], fi);
  P1.x=(P1.x*P1.x+P1.y*P1.y)*M[1]/2+fit*fit*J[1]/2;
  P1.y=P1.x;
  return P1;
}

PT Z2(PT Point, double fi)
{
  PT P1;

  P1.x=Xb(Point, fi);
  P1.y=Yb(Point, fi);
  return P1;
}

PT Z2_t(PT Point, double fi)
{
  PT P1,Pn,A_t,A;

  A_t=Z1_t(a,fi);
  A=  Z1  (a,fi);
  Pn=Z2(Point,fi);

  P1.x=A_t.x-psi_t(fi)*(Pn.y-A.y);
  P1.y=A_t.y+psi_t(fi)*(Pn.x-A.x);

  return P1;
}

PT Z2_tt(PT Point, double fi)
{
  PT P1,Pn,Pn_t,A_tt,A_t,A;

  A_tt=Z1_tt(a,fi);
  A_t= Z1_t (a,fi);
  A=   Z1   (a,fi);
  Pn=Z2(Point,fi);
  Pn_t=Z2_t(Point,fi);

  P1.x=A_tt.x-psi_tt(fi)*(Pn.y-A.y)-psi_t(fi)*(Pn_t.y-A_t.y);
  P1.y=A_tt.y+psi_tt(fi)*(Pn.x-A.x)+psi_t(fi)*(Pn_t.x-A_t.x);
  return Norm(P1);
}

#pragma argsused
PT Z2_E(PT Point, double fi)
{
  PT P1;
  double psit;

  psit=psi_t(fi);
  P1=Z2_t(MC[2], fi);
  P1.x=(P1.x*P1.x+P1.y*P1.y)*M[2]/2+psit*psit*J[2]/2;
  P1.y=P1.x;
  return P1;
}

PT Z3(PT Point, double fi)
{
  PT P1;

  P1.x=o1.x+(Point.x-o1.x)*cos(ksi(fi)-ksi(fi0))-(Point.y-o1.y)*sin(ksi(fi)-ksi(fi0));
  P1.y=o1.y+(Point.x-o1.x)*sin(ksi(fi)-ksi(fi0))+(Point.y-o1.y)*cos(ksi(fi)-ksi(fi0));
  return P1;
}

PT Z3_t(PT Point, double fi)
{
  PT P1,Pn,A_t,A;
  Pn=Z3(Point,fi);
  P1.x=-ksi_t(fi)*(Pn.y-o1.y);
  P1.y=ksi_t(fi)*(Pn.x-o1.x);
  return P1;
}

PT Z3_tt(PT Point, double fi)
{
  PT P1,Pn,Pn_t;

  Pn=Z3(Point,fi);
  Pn_t=Z3_t(Point,fi);

  P1.x=-ksi_t(fi)*Pn_t.y-ksi_tt(fi)*(Pn.y-o1.y);
  P1.y=ksi_t(fi)*Pn_t.x+ksi_tt(fi)*(Pn.x-o1.x);
  return Norm(P1);
}

#pragma argsused
PT Z3_E(PT Point, double fi)
{
  PT P1;
  double ksit;

  ksit=ksi_t(fi);
  P1=Z3_t(MC[3], fi);
  P1.x=(P1.x*P1.x+P1.y*P1.y)*M[3]/2+ksit*ksit*J[3]/2;
  P1.y=P1.x;
  return P1;
}

PT Z4(PT Point, double fi)
{
  PT P1;


  P1.x=Xb(d,fi)+(Point.x-Xb(d,fi0))*cos(my(fi)-my(fi0))-(Point.y-Yb(d,fi0))*sin(my(fi)-my(fi0));
  P1.y=Yb(d,fi)+(Point.x-Xb(d,fi0))*sin(my(fi)-my(fi0))+(Point.y-Yb(d,fi0))*cos(my(fi)-my(fi0));

  return P1;
}

PT Z4_t(PT Point, double fi)
{
  PT P1,Pn,D_t,D;

  D_t=Z2_t(d,fi);
  D=  Z2  (d,fi);
  Pn=Z4(Point,fi);

  P1.x=D_t.x-my_t(fi)*(Pn.y-D.y);
  P1.y=D_t.y+my_t(fi)*(Pn.x-D.x);

  return P1;
}

PT Z4_tt(PT Point, double fi)
{
  PT P1,Pn,Pn_t,D_tt,D_t,D;

  D_tt=Z2_tt(d,fi);
  D_t= Z2_t (d,fi);
  D=   Z2   (d,fi);
  Pn=Z4(Point,fi);
  Pn_t=Z4_t(Point,fi);

  P1.x=D_tt.x-my_tt(fi)*(Pn.y-D.y)-my_t(fi)*(Pn_t.y-D_t.y);
  P1.y=D_tt.y+my_tt(fi)*(Pn.x-D.x)+my_t(fi)*(Pn_t.x-D_t.x);
  return Norm(P1);
}

#pragma argsused
PT Z4_E(PT Point, double fi)
{
  PT P1;
  double myt;

  myt=my_t(fi);
  P1=Z4_t(MC[4], fi);
  P1.x=(P1.x*P1.x+P1.y*P1.y)*M[4]/2+myt*myt*J[4]/2;
  P1.y=P1.x;
  return P1;
}

PT Z5(PT Point, double fi)
{
  PT P1;

  P1.x=Xb(b,fi)+(Point.x-b.x);
  P1.y=Yb(b,fi)+(Point.y-b.y);
  return P1;
}

#pragma argsused
PT Z5_t(PT Point, double fi)
{
  return Z2_t(b,fi);
}

#pragma argsused
PT Z5_tt(PT Point, double fi)
{
  return Z2_tt(b,fi);
}

#pragma argsused
PT Z5_E(PT Point, double fi)
{
  PT P1;

  P1=Z5_t(MC[5], fi);
  P1.x=(P1.x*P1.x+P1.y*P1.y)*M[5]/2;
  P1.y=P1.x;
  return P1;
}

#pragma argsused
PT F_b(PT Point, double fi)
{
  return Norm(Z5_tt(MC[5],fi)*M[5]);
}

#pragma argsused
PT F_k(PT Point, double fi)
{
  return Norm(Z5_tt(MC[5],fi)*M[5]);
}

#pragma argsused
PT F_d(PT Point, double fi)
{
  double Md,Mc4,tmp;
  PT  Qd,Qk,Fc4,Rd,Sd,K,D,c4,K_t;

  c4=Z4(MC[4],fi);
  D=Z4(d,fi);
  K=Z4(k,fi);
  K_t=Z4_t(k,fi);
  
  Qk=F_k(Point,fi);
  Fc4=Z4_tt(MC[4],fi)*M[4];
  Mc4=my_tt(fi)*J[4];
  Qd=Qk+Fc4;
  Md=Mc4-Qk.x*(K.y-D.y)-Fc4.x*(c4.y-D.y)+Qk.y*(K.x-D.x)+Fc4.y*(c4.x-D.x);
  tmp=(K.x-D.x)*K_t.x+(K.y-D.y)*K_t.y;
  Rd.x=Md*K_t.y/tmp;
  Rd.y=Md*K_t.x/tmp;
  Sd=Qd+Rd;
  return Norm(Sd);
}

#pragma argsused
PT F_a(PT Point, double fi)
{
  double Ma,Mc2,Raa;
  PT  Qa,Fc2,Ra,Sa,Qb,B,A,c2;

  c2=Z2(MC[2],fi);
  B=Z2(b,fi);
  A=Z1(a,fi);
  Qb=F_b(Point, fi);

  Fc2=Z2_tt(MC[2],fi)*M[2];
  Mc2=psi_tt(fi)*J[2];

  Qa.x=Fc2.x-Qb.x;
  Qa.y=Fc2.y;

  Ma=Fc2.x*(c2.y-A.y)+Qb.x*(B.y-A.y)+Mc2;

  Ra.y=-Ma/(B.x-B.y);
  Sa.x=Qa.x;
  Sa.y=Qa.y+Ra.y;
  return Norm(Sa);
}



double Xa(PT Point, double fi)
{
  return Point.x*cos(fi-fi0)-Point.y*sin(fi-fi0);
}

double Ya(PT Point, double fi)
{
  return Point.x*sin(fi-fi0)+Point.y*cos(fi-fi0);
}

# define ksi0 ksi(fi0)
# define psi0 psi(fi0)
# define alpha_B alpha_A+L[2]*cos(psi0)
# define beta_B  beta_A+L[2]*sin(psi0)
# define d_psi psi(fi)-psi0

double Xb(PT Point, double fi)
{
  return Xa(a,fi)+(Point.x-alpha_A)*cos(d_psi)-(Point.y-beta_A)*sin(d_psi);
}

double Yb(PT Point, double fi)
{
  return Ya(a,fi)+(Point.x-alpha_A)*sin(d_psi)+(Point.y-beta_A)*cos(d_psi);
}

#pragma argsused
double Xk(PT Point, double fi)
{
  return Xb(b,fi)-L[2]*cos(psi(fi));
}

#pragma argsused
double Yk(PT Point, double fi)
{
  return Yb(d,fi)-L[2]*sin(psi(fi));
}



#pragma argsused
PT P_K(PT Point, double fi)
{
  PT P1,P2;

  double d_fi=0.000001;
  P1=Z5_E(Point, fi+d_fi);
  P2=Z5_E(Point, fi);

  P1.x=(P1.x-P2.x)/d_fi*fi_t(fi);
  P1.y=P1.x;
  return P1;
}

#pragma argsused
PT P_D(PT Point, double fi)
{
  PT P1,P2;

  double d_fi=0.000001;
  P1=Z4_E(Point, fi+d_fi);
  P2=Z4_E(Point, fi);

  P1.x=(P1.x-P2.x)/d_fi*fi_t(fi);
  P2=P_K(Point, fi);
  P1.x+=P2.x;
  P1.y=P1.x;
  return P1;
}

#pragma argsused
PT P_B(PT Point, double fi)
{
  PT P1,P2;

  double d_fi=0.000001;
  P1=Z5_E(Point, fi+d_fi);
  P2=Z5_E(Point, fi);

  P1.x=(P1.x-P2.x)/d_fi*fi_t(fi);
  P1.y=P1.x;
  return P1;
}

#pragma argsused
PT P_A(PT Point, double fi)
{
  PT P1,P2;

  double d_fi=0.000001;
  P1=Z2_E(Point, fi+d_fi);
  P2=Z2_E(Point, fi);

  P1.x=(P1.x-P2.x)/d_fi*fi_t(fi);
  P2=P_B(Point, fi);
  P1.x+=P2.x;
  P1.y=P1.x;
  return P1;
}

#pragma argsused
PT P_O(PT Point, double fi)
{
  PT P1,P2;

  double d_fi=0.000001;
  P1=Z1_E(Point, fi+d_fi);
  P2=Z1_E(Point, fi);

  P1.x=(P1.x-P2.x)/d_fi*fi_t(fi);
  P2=P_A(Point, fi);
  P1.x+=P2.x;
  P1.y=P1.x;
  return P1;
}

#pragma argsused
int PASCAL WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
  MSG msg;
  WNDCLASS  wcSample,Grph;
  HWND hwnd;

  RECT  rc;

  GetWindowRect(GetDesktopWindow(),&rc);

  WinSizeX=rc.right/2;
  WinSizeY=rc.bottom/2-20;

  Red=   CreatePen(PS_SOLID, 0, RGB(200, 0, 0));
  Green= CreatePen(PS_SOLID, 3, RGB(0, 200, 0));
  Green0=CreatePen(PS_SOLID, 0, RGB(0, 200, 0));
  Blue=  CreatePen(PS_SOLID, 0, RGB(0, 0, 200));
  Black= CreatePen(PS_SOLID, 0, RGB(0, 0,   0));

  fi=fi0;
  mm.x=0;
  mm.y=10;

  L[1]=35.0;
  L[2]=62.0;
  L[3]=33.0;
  L[4]=47.0;
  L[5]=32.0;
  L[6]=50.0;
  L[7]=0;
  L[8]=0;
  L[9]=0;

  M[1]=1;
  M[2]=1;
  M[3]=1;
  M[4]=1;
  M[5]=1;
  M[6]=1;
  M[7]=1;
  M[8]=0;
  M[9]=0;

  J[1]=1;
  J[2]=1;
  J[3]=1;
  J[4]=1;
  J[5]=1;
  J[6]=1;
  J[7]=0;
  J[8]=0;
  J[9]=0;

  Bmain.x=2;
  Bmain.y=2;
  
  wcSample.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
  wcSample.lpfnWndProc = (WNDPROC)WndProc;
  wcSample.cbClsExtra = 0;
  wcSample.cbWndExtra = 0;
  wcSample.hInstance = hInstance;
  wcSample.hIcon = LoadIcon( NULL, IDI_APPLICATION );
  wcSample.hCursor = LoadCursor(NULL, IDC_ARROW);
  wcSample.hbrBackground = (HBRUSH)(COLOR_WINDOW + 1);
  wcSample.lpszMenuName =  MAKEINTRESOURCE(IDR_MENU_MAIN);
  wcSample.lpszClassName = "SampleWClass";

  Grph=wcSample;
  Grph.lpfnWndProc = (WNDPROC)Graph;
  Grph.lpszMenuName = 0;
  Grph.lpszClassName = "Graph";

  GraphWindow=(GRPH*)GlobalAlloc(GPTR,GraphWindowNum*sizeof(GRPH));

  if (!RegisterClass(&wcSample)) return (FALSE);
  if (!RegisterClass(&Grph)) return (FALSE);

  hInst=hInstance;
  hwnd = CreateWindow("SampleWClass","qwer",WS_OVERLAPPEDWINDOW, 0,0, WinSizeX,WinSizeY, NULL,NULL,hInstance,NULL);
  MainWin=hwnd;

  HMENU hmenu = GetSubMenu(GetMenu(hwnd), 1);
  for(int i=0;i<MaxForm;++i)
  {
    AppendMenu(hmenu,MF_STRING,Form[i].form_id,Form[i].Menu);
  }
  
  DialogBox(hInstance,"PARAM", hwnd, (DLGPROC)ParamDlgProc);

  while(GetMessage(&msg,NULL,0,0))
    {
       TranslateMessage (&msg);
       DispatchMessage (&msg);
    }
  return (msg.wParam);
}

LRESULT FAR PASCAL WndProc(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
  HANDLE h;
  PT Pt;
  RECT  rcClient;        // size of client area
  int Shift;
  switch (message)
  {
    case WM_CREATE:
      ShowWindow(hwnd,SW_SHOW);
      qhdc=GetDC(hwnd);
      MemHdc=CreateCompatibleDC(qhdc);
      GetClientRect(hwnd, &rcClient);
      Bitmap=CreateCompatibleBitmap(qhdc,rcClient.right,rcClient.bottom);
      SelectObject(MemHdc,Bitmap);
      DrawGDIOutput(hwnd,MemHdc);
      break;
    case WM_DESTROY:
      PostQuitMessage(0);
      break;
    case WM_PAINT:
      MsgPaint(hwnd,(HDC)wParam);
      break;
    case WM_SIZE:
      qhdc=GetDC(hwnd);
      DeleteDC(MemHdc);
      DeleteObject(Bitmap);
      MemHdc=CreateCompatibleDC(qhdc);
      Bitmap=CreateCompatibleBitmap(qhdc,LOWORD(lParam),HIWORD(lParam));
      SelectObject(MemHdc,Bitmap);
      DrawGDIOutput(hwnd,MemHdc);
      break;
    case WM_MOUSEMOVE:
      if(MsgMouseMove(wParam, LOWORD(lParam), HIWORD(lParam))!=0)
      {
        Param2Dlg();
        RedrawWindow(hwnd,NULL,NULL,/*RDW_ERASE |*/ RDW_INVALIDATE | RDW_UPDATENOW);
      }
      break;
    case WM_KEYDOWN:
      if(wParam==0x10)
        ShiftState=1;
      break;
    case WM_KEYUP:
      if(wParam==0x10)
        if(((GetAsyncKeyState(VK_ADD) & 0x8000) | (GetAsyncKeyState(VK_SUBTRACT) & 0x8000))==0)
          ShiftState=0;
      break;
    case WM_CHAR:
      Shift=ShiftState;
      if(wParam==9)
      {
        if(Shift==0)
          if(Select<2)
            ++Select;
          else
          {
            if(Select==9)
              Select=0;
            if(Select==7)
              Select=9;
            if(Select==2)
              Select=7;
          }
        else

          if(Select==1 || Select==2)
            --Select;
          else
          {
            if(Select==7)
              Select=2;
            if(Select==9)
              Select=7;
            if(Select==0)
              Select=9;
          }
        Param2Dlg();
        RedrawWindow(hwnd,NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
      }
      if(wParam==0x1b)
      {
        Select=0;
        Param2Dlg();
        RedrawWindow(hwnd,NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
      }
      if(wParam==0x2b)
      {
        if(Shift==0)
        {
          Bmain.y=Bmain.y*2;
          Bmain.x=Bmain.x*2;
        }
        else
        {
          Bv.y=Bv.y*2;
          Bv.x=Bv.x*2;
        }
        RedrawWindow(hwnd,NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
      }
      if(wParam==0x2d)
      {
        if(Shift==0)
        {
          Bmain.y=Bmain.y/2;
          Bmain.x=Bmain.x/2;
        }
        else
        {
          Bv.y=Bv.y/2;
          Bv.x=Bv.x/2;
        }
        RedrawWindow(hwnd,NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
      }
      break;
    case WM_CONTEXTMENU:
      MsgContextMenu((HWND) wParam, LOWORD(lParam), HIWORD(lParam));
      break;
    case WM_COMMAND:
      MsgCommand(LOWORD(wParam));
      break;
    default:
      return (DefWindowProc(hwnd, message, wParam, lParam));
  }
  return 0;
}

MsgCommand(int ID)
{
  PT P;
  FN_ Fn;
  int Action=1,i;
  int MenuState,nn,n;
  HMENU Main,Display;
  char name[100];
  switch (ID)
  {
    case ID_V_K:
      Fn=Z4_t;
      n=4;
      nn=1;
      break;
    case ID_V_D:
      Fn=Z2_t;
      n=3;
      nn=1;
      break;
    case ID_V_B:
      Fn=Z2_t;
      n=2;
      nn=1;
      break;
    case ID_V_A:
      Fn=Z1_t;
      n=1;
      nn=1;
      break;

    case ID_A_K:
      Fn=Z4_tt;
      n=4;
      nn=2;
      break;
    case ID_A_D:
      Fn=Z2_tt;
      n=3;
      nn=2;
      break;
    case ID_A_B:
      Fn=Z2_tt;
      n=2;
      nn=2;
      break;
    case ID_A_A:
      Fn=Z1_tt;
      n=1;
      nn=2;
      break;

    case ID_F_K:
      Fn=F_k;
      n=4;
      nn=3;
      break;
    case ID_F_D:
      Fn=F_d;
      n=3;
      nn=3;
      break;
    case ID_F_B:
      Fn=F_b;
      n=2;
      nn=3;
      break;
    case ID_F_A:
      Fn=F_a;
      n=1;
      nn=3;
      break;

    case ID_P_K:
      Fn=P_K;
      n=4;
      nn=4;
      break;
    case ID_P_D:
      Fn=P_D;
      n=3;
      nn=4;
      break;
    case ID_P_B:
      Fn=P_B;
      n=2;
      nn=4;
      break;
    case ID_P_A:
      Fn=P_A;
      n=1;
      nn=4;
      break;
    case ID_P_O:
      Fn=P_O;
      n=0;
      nn=4;
      break;

    case ID_E_Z5:
      Fn=Z5_E;
      n=5;
      nn=5;
      break;
    case ID_E_Z4:
      Fn=Z4_E;
      n=4;
      nn=5;
      break;
    case ID_E_Z3:
      Fn=Z3_E;
      n=3;
      nn=5;
      break;
    case ID_E_Z2:
      Fn=Z2_E;
      n=2;
      nn=5;
      break;
    case ID_E_Z1:
      Fn=Z1_E;
      n=1;
      nn=5;
      break;

    case ID_MENUITEM_VA:
      Action=2;
      MenuState=ShowV=ShowV*(-1);
      ShowA=ShowA*(-1);
      break;
    case ID_MENUITEM_F:
      Action=2;
      MenuState=ShowF=ShowF*(-1);
      break;
    case ID_MENUITEM_E:
      Action=2;
      MenuState=ShowE=ShowE*(-1);
      break;
    case ID_MENUITEM_P:
      Action=2;
      MenuState=ShowP=ShowP*(-1);
      break;

    case ID_MENUITEM_HELP:
      Action=0;
      DialogBox(hInst,"HELP", MainWin, (DLGPROC)HelpDlgProc);
      break;

    default:
      for(i=0;i<MaxForm;++i)
        if(Form[i].form_id==ID)
          break;
      if(i!=MaxForm)
      {
        Action=0;
        form_num=i;
        DialogBox(hInst,"START_PARAM", MainWin, (DLGPROC)StartParamDlgProc);
      }
      else
        return 0;
  }


  if(Action==1)
  {
    if(nn==1)
      lstrcpy(name,"  ");
    if(nn==2)
      lstrcpy(name,"  ");
    if(nn==3)
      lstrcpy(name,"   ");
    if(nn==4)
      lstrcpy(name,"   ");
    if(nn==5)
      lstrcpy(name,"  ");
    if(nn!=5)
    {
      if(n==0)
      {
        P=o;
        lstrcat(name,"O");
      }
      if(n==1)
      {
        P=a;
        lstrcat(name,"A");
      }
      if(n==2)
      {
        P=b;
        lstrcat(name,"B");
      }
      if(n==3)
      {
        P=d;
        lstrcat(name,"D");
      }
      if(n==4)
      {
        P=k;
        lstrcat(name,"K");
      }
      else;
    }
    else
    {
       P=MC[n];
       wsprintf(name,"%s%i",name,n);
    }

    PT *pt;
    PNum=360;
    Step=2*M_PI/PNum;
  
    pt=(PT *)GlobalAlloc(GPTR,(PNum+1)*sizeof(PT));
    double angle;
    int i;
    Error=0;
    for(i=0,angle=0;angle<2*M_PI;++i,angle+=Step)
    {
      asm
      {
        FSAVE FPU
        WAIT
        FRSTOR FPU
      }
      try
      {      
        pt[i]=Fn(P,angle+fi0);
      }
      __except(EXCEPTION_EXECUTE_HANDLER)
      {
        asm
        {
          FRSTOR FPU
        }
        Error=1;
      }
      if(Error!=0)
      {
        pt[i].x=pt[i-1].x;
        pt[i].y=pt[i-1].y;
        Error=0;
      }
    }
    FilledFlag=1;
    for(i=0;i<GraphWindowNum;++i)
      if(GraphWindow[i].hwnd==NULL)
        break;
    GraphWindow[i].PointNum=PNum;
    GraphWindow[i].Point=pt;
  
    int j,f=0;
    for(j=0;j<3;++j)
      if(GraphPos[j]<GraphPos[f])
       f=j;
    ++GraphPos[f];
    GraphWindow[i].GraphPos=&GraphPos[f];
    int x=0,y=0;
    if(f==0)
      x=WinSizeX;
    if(f==1)
    {
      x=WinSizeX;
      y=WinSizeY;
    }
    if(f==2)
      y=WinSizeY;
  
    CreateWindow("Graph",name,WS_OVERLAPPEDWINDOW, x,y, WinSizeX,WinSizeY, NULL,NULL,NULL,NULL);
  }
  if(Action==2)
  {
    Main=GetMenu(MainWin);
    if(MenuState==-1)
      MenuState=MF_UNCHECKED;
    else
      MenuState=MF_CHECKED;
    CheckMenuItem(Main,ID,MenuState);
    RedrawWindow(MainWin,NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
  }
  return 0;
}

#pragma argsused
void MsgContextMenu(HWND hwnd, WORD xPos, WORD yPos)
{
//  HMENU menu;
//  menu=CreatePopupMenu();
//  AppendMenu(menu,MF_STRING,1,"");
}

int MsgMouseMove(int fwKeys, int xPos, int yPos)
{
  xEnd=xPos;
  yEnd=yPos;
  fl=fwKeys;
  if(fl==0)
  {
    delta_p=0;
    xStart=xPos;
    yStart=yPos;
  }
  return fl;
}

#pragma argsused
LRESULT MsgPaint(HWND hwnd, HDC hdc)
{
    RECT  rcClient;        // size of client area
    PAINTSTRUCT ps;

    do
    {
      if(StatusSaved==0)
        SaveStat();
      else
        StatusSaved=0;
      asm
      {
        FSAVE FPU
        WAIT
        FRSTOR FPU
      }
      try
      {      
      DrawGDIOutput(hwnd,MemHdc);
      }
      __except(EXCEPTION_EXECUTE_HANDLER)
      {
        asm
        {
          FRSTOR FPU
        }
        Error=1;

      }
      if(Error==1)
      {
        RestoreStat();
        fl=0;
      }
    }while(Error==1);
    BeginPaint(hwnd, &ps);
    GetClientRect(hwnd, &rcClient);
    BitBlt(ps.hdc,0,0,rcClient.right,rcClient.bottom,MemHdc,0,0,SRCCOPY);
    EndPaint(hwnd, &ps);
    return 0;
}

void DrawGDIOutput(HWND hwnd, HDC hdc)
{
    RECT  rcClient;        // size of client area
    double x1,y1,f1,dp,tmp1;
    char str[0x100];

    BB=Bmain;
//    SetROP2(hdc,R2_NOTXORPEN);
    GetClientRect(hwnd, &rcClient);
    FillRect(hdc,&rcClient,(HBRUSH)(COLOR_WINDOW + 1));
     xmax=rcClient.right;
     ymax=rcClient.bottom;
     x_0 = xmax/2-100;
     y_0 = ymax/2;

   delta=xEnd-xStart;
   dp=delta-delta_p;
   if(Error==1)
     dp=dp/10;
   Error=0;
   if(fl==2)
     fi=fi-dp/70;
   if(FirstStartFl!=0)
     if(fi!=fi0)
       FirstStartFl=0;

   if(Select>0 && Select<8)
   {
     if(fl==1 && Select!=8)
     {
       L[Select]=L[Select]-dp;
       sprintf(str,"L%i=%f",Select,L[Select]);
       TextOut(hdc,0,0,str,lstrlen(str));
     }
     if(fl==3)
     {
       if(fi!=fi0)
       {
         MC_changed=1;
         Error=1;
         fi_p=fi0;
       }
       else
       {
         MC_changed=1;
         int i=Select;
         if(i==4 || i==5)
           i=2;
         if(i==6 || i==7)
           i-=2;
         MC[i].x=(xEnd-x_0)/BB.x;
         MC[i].y=(y_0-yEnd)/BB.y;
       }
     }
   }
   if(Select==9)
   {
     if(fl==1)
     {
       mm.x=(xEnd-x_0)/BB.x;
       mm.y=(y_0-yEnd)/BB.y;
       sprintf(str,"m=%f",m);
       TextOut(hdc,0,0,str,lstrlen(str));
     }
     if(fl==3)
     {
//       beta=beta-dp/70;
       if(beta<-M_PI)
         beta+=2*M_PI;
       if(beta>M_PI)
         beta-=2*M_PI;
       sprintf(str,"beta=%f",beta/M_PI*180);
       TextOut(hdc,0,0,str,lstrlen(str));
     }
   }
   if(Select==8 && fl==1)
   {
     o1.x=(xEnd-x_0)/BB.x;
     o1.y=(y_0-yEnd)/BB.y;
     sprintf(str,"Xo1=%f  Yo1=%f",o1.x,o1.y);
     TextOut(hdc,0,0,str,lstrlen(str));
   }
   delta_p=delta;

  m=-(mm.x*tan(beta)-mm.y);
  a.x=alpha_A;
  a.y=beta_A;
  b.x=alpha_B;
  b.y=beta_B;
/*
  tmp1=(L[2]*L[2]+L[4]*L[4]-L[5]*L[5])/(2*L[2]*L[4]);
  if(abs(tmp1)>1-0.000000001)
  {
    Error=1;
    return;
  }
  double dlt0=acos(tmp1)+psi(fi0);
  d.x=a.x+L[4]*cos(dlt0);
  d.y=a.y+L[4]*sin(dlt0);
  k.x=d.x-L[6]*cos(my(fi0));
  k.y=d.y-L[6]*sin(my(fi0));
*/
  if(MC_changed==0)
  {
    MC[1]=a/2;
    MC[2]=(a+b)/2;
    MC[5]=b;
  }

   if(FilledFlag!=1)
   {
     if(FilledFlag!=-1)
       Free();
     Fill();
   }

   SelectObject(hdc, Green);

   DWORD cl=RGB(0, 0, 200);
   if(Select==9)
   {
     cl=RGB(200, 0, 0);
   }
   if(abs(beta)<M_PI/4)
     for(int i=-x_0;i<=xmax-x_0;++i)
       SetPixel(hdc,x_0+i,y_0-(m*BB.y+i*tan(beta)),cl);
   else
     for(int i=-y_0;i<=y_0;++i)
       SetPixel(hdc,x_0+(i-m*BB.x)/tan(beta),y_0-i,cl);

   SelectObject(hdc, Green);
   LineZ(hdc,o,Z1(a,fi),1);
   LineZ(hdc,ptNULL,Z2(b,fi),2);

   CircleF(hdc, Z1(a,fi), 5);
   CircleF(hdc, Z2(b,fi), 5);

   Sharnir(hdc, o, -1);

   Polzun(hdc, Z2(b,fi), 0, 7);

   Cross(hdc,Z1(MC[1],fi),Black);
   Cross(hdc,Z2(MC[2],fi),Black);
   Cross(hdc,Z5(MC[5],fi),Black);

   if(ShowV==1 && FirstStartFl==0)
   {
     Vektor_v(hdc,Z1(a,fi),Z1_t(a,fi),Red);
     Vektor_v(hdc,Z2(b,fi),Z2_t(b,fi),Red);
   }
   if(ShowA==1 && FirstStartFl==0)
   {
     Vektor_v(hdc,Z1(a,fi),Z1_tt(a,fi),Black);
     Vektor_v(hdc,Z2(b,fi),Z2_tt(b,fi),Black);
   }
   if(ShowF==1 && FirstStartFl==0)
   {
     Vektor_v(hdc,Z2(b,fi),F_b(b,fi),Blue);
     Vektor_v(hdc,Z1(a,fi),F_a(a,fi),Blue);
   }
   if(ShowE==1 && FirstStartFl==0)
   {
     Energy(hdc, Z1(MC[1],fi), Z1_E(MC[1],fi), Red);
     Energy(hdc, Z2(MC[2],fi), Z2_E(MC[2],fi), Red);
     Energy(hdc, Z5(MC[5],fi), Z5_E(MC[5],fi), Red);
   }
   if(ShowP==1 && FirstStartFl==0)
   {
     Energy(hdc, o,        P_O(o,fi), Black);
     Energy(hdc, Z1(a,fi), P_A(a,fi), Black);
     Energy(hdc, Z2(b,fi), P_B(b,fi), Black);
   }

   if(FirstStartFl!=0)
   {
     Text(hdc, Z1(a,fi), RGB(200,0,0), TA_BOTTOM | TA_LEFT, "A");
     Text(hdc, Z2(b,fi), RGB(200,0,0), TA_BOTTOM | TA_LEFT, "B");
     Text(hdc, Z1(o,fi), RGB(200,0,0), TA_BOTTOM | TA_LEFT, "O");

     Text(hdc, Z1(MC[1],fi), RGB(0,0,200), TA_BASELINE | TA_CENTER, "Z1");
     Text(hdc, Z2(MC[2],fi), RGB(0,0,200), TA_BASELINE | TA_RIGHT, "Z2");
     Text(hdc, Z5(MC[5],fi), RGB(0,0,200), TA_TOP | TA_RIGHT, "Z5");
   }

   if(fl==1 && Select==0)
   {
     if(xEnd-xStart!=0)
       f1=atan((double)(yEnd-yStart)/(double)(xEnd-xStart)*-1)/M_PI*180;
     else
       if(yEnd-yStart!=0)
         f1=90;
       else
         f1=0;
     if(xEnd-xStart<0 && yEnd-yStart<=0)
       f1=180+f1;
     if(xEnd-xStart<=0 && yEnd-yStart>0)
       f1=180+f1;
     if(xEnd-xStart>0 && yEnd-yStart>0)
       f1=360+f1;

     SelectObject(hdc, Red);
     MoveToEx(hdc,xStart,yStart,NULL);
     LineTo(hdc,xEnd,yEnd);
     sprintf(str,"%f %f",sqrt((xEnd-xStart)*(xEnd-xStart)/BB.x+(yEnd-yStart)*(yEnd-yStart)/BB.y),f1);
     TextOut(hdc,0,0,str,lstrlen(str));
   }
   else
   {
     if(fl!=1 && fl!=3)
     {
       sprintf(str,"fi=%f",fi/M_PI*180);
       TextOut(hdc,0,0,str,lstrlen(str));
     }
   }
}

void SaveStat()
{
  for(int i=0;i<9;++i)
    L_p[i]=L[i];
  fi_p=fi;
  beta_p=beta;
  m_p=m;
  o1_p=o1;
  mm_p=mm;
}

void RestoreStat()
{
  for(int i=0;i<9;++i)
    L[i]=L_p[i];
  fi=fi_p;
  beta=beta_p;
  m=m_p;
  o1=o1_p;
  mm=mm_p;
}

void PSet(HDC hdc, PT Point, COLORREF crColor)
{
  SetPixel(hdc, x_0+Point.x*BB.x, y_0-Point.y*BB.y, crColor);
}

HPEN Line(HDC hdc, PT Point1, PT Point2, HPEN Pen)
{
  HPEN PrevPen=NULL;
  double x1,y1,x2,y2;

  x1=x_0+Point1.x*BB.x;
  y1=y_0-Point1.y*BB.y;
  x2=x_0+Point2.x*BB.x;
  y2=y_0-Point2.y*BB.y;

  if(Point1.x!=ptNULL.x || Point1.y!=ptNULL.y)
    MoveToEx(hdc, x1, y1, NULL);
  if(Pen!=NULL)
    PrevPen=(HPEN)SelectObject(hdc, Pen);
  LineTo(hdc,x2, y2);

  return PrevPen;
}

void LineZ(HDC hdc, PT Point1, PT Point2, int Num)
{
  HPEN Pen=NULL;

  if(Num==Select)
    Pen=Red;
  Pen=Line(hdc, Point1, Point2, Pen);
  if(Pen!=NULL)
    SelectObject(hdc, Pen);
}

void CircleF(HDC hdc, PT Point, double r)
{
  double x,y,x1,y1,x2,y2;

  x=x_0+Point.x*BB.x;
  y=y_0-Point.y*BB.y;
  x1=x-r;
  y1=y-r;
  x2=x+r;
  y2=y+r;
  Ellipse(hdc,x1,y1,x2,y2);
}

void Circle(HDC hdc, PT Point, double r1)
{
  double x,y,x1,y1,x2,y2,r;

  r=r1;
  if(r<0)
    r=r*(-1);
  if(r>10000)
    r=10000;
  x=x_0+Point.x*BB.x;
  y=y_0-Point.y*BB.y;
  x1=x-r;
  y1=y-r;
  x2=x+r;
  y2=y+r;
  Arc(hdc,x1,y1,x2,y2,0,0,0,0);
}

void Sharnir(HDC hdc, PT Point, int Num)
{
  PT Point1,Point2;

  Point1.x=Point.x-5/BB.x*1.5;
  Point1.y=Point.y-10/BB.y*1.5;
  Point2.x=Point.x+5/BB.x*1.5;
  Point2.y=Point.y-10/BB.y*1.5;

  LineZ(hdc, Point1, Point, Num);
  LineZ(hdc, ptNULL, Point2, Num);
  
  Point1.x-=5/BB.x*1.5;
  Point2.x+=5/BB.y*1.5;
  LineZ(hdc, Point1, Point2, Num);
  CircleF(hdc, Point, 5);
}

void Polzun(HDC hdc, PT Point, double fi, int Num)
{
  PT Point1,Point2,Point3,Point4;

  Point1.x=Point.x-10/BB.x*1.5;
  Point1.y=Point.y-5/BB.y*1.5;
  Point2.x=Point.x+10/BB.x*1.5;
  Point2.y=Point.y-5/BB.y*1.5;
  Point3.x=Point.x+10/BB.x*1.5;
  Point3.y=Point.y+5/BB.y*1.5;
  Point4.x=Point.x-10/BB.x*1.5;
  Point4.y=Point.y+5/BB.y*1.5;

  Point1=Turn(Point1, Point, fi);
  Point2=Turn(Point2, Point, fi);
  Point3=Turn(Point3, Point, fi);
  Point4=Turn(Point4, Point, fi);

  LineZ(hdc, Point1, Point2, Num);
  LineZ(hdc, ptNULL, Point3, Num);
  LineZ(hdc, ptNULL, Point4, Num);
  LineZ(hdc, ptNULL, Point1, Num);
}


void Cross(HDC hdc, PT Point, HPEN Pen)
{
  PT Point1,Point2,Point3,Point4;
  HPEN Pen1;

  Point1.x=Point.x-2.0/BB.x;
  Point1.y=Point.y-2.0/BB.y;
  Point2.x=Point.x+2.0/BB.x;
  Point2.y=Point.y-2.0/BB.y;
  Point3.x=Point.x+2.0/BB.x;
  Point3.y=Point.y+2.0/BB.y;
  Point4.x=Point.x-2.0/BB.x;
  Point4.y=Point.y+2.0/BB.y;

  Pen1=Line(hdc, Point1, Point3, Pen);
  Line(hdc, Point2, Point4, Pen);
  if(Pen1!=NULL)
    SelectObject(hdc, Pen1);
}

PT Turn(PT Point, PT Polus, double fi)
{
  PT Point1;
  double L,alpha,beta;

  L=sqrt((Polus.x-Point.x)*(Polus.x-Point.x)+(Polus.y-Point.y)*(Polus.y-Point.y));
  beta=Angle(Point, Polus);
  alpha=fi+beta;
  Point1.x=Polus.x+L*cos(alpha);
  Point1.y=Polus.y+L*sin(alpha);
  return Point1;
}

double Angle(PT Point, PT Polus)
{
  double beta,dy,dx;
  dy=Point.y-Polus.y;
  dx=Point.x-Polus.x;
  if(abs(dx)<0.00000000001)
    if(dy==0)
      beta=0;
    else
      beta=M_PI/2;
  else
    beta=atan(dy/dx);
  if(Point.x<Polus.x)
    beta+=M_PI;
  return beta;
}
//double Angle2(PT Point1, PT Point2, PT Polus)
//{
//}
void Vektor(HDC hdc, PT Polus, PT Point, HPEN Pen)
{
  PT Point3,Point4;
  double alpha;
  HPEN Pen1;

  Point3.x=Point.x-10/BB.x;
  Point3.y=Point.y-5/BB.y;
  Point4.x=Point.x-10/BB.x;
  Point4.y=Point.y+5/BB.y;

  alpha=Angle(Point, Polus);
  Point3=Turn(Point3, Point, alpha);
  Point4=Turn(Point4, Point, alpha);

  Pen1=Line(hdc, Polus, Point, Pen);
  Line(hdc, Point, Point3, Pen);
  Line(hdc, Point, Point4, Pen);
  if(Pen1!=NULL)
    SelectObject(hdc, Pen1);
}

void Vektor_v(HDC hdc, PT Polus, PT Point, HPEN Pen)
{
  Point.x=Point.x*Bv.x/Bmain.x;
  Point.y=Point.y*Bv.y/Bmain.y;
  Vektor(hdc,Polus,Point+Polus,Pen);
}

void Energy(HDC hdc, PT Polus, PT Point, HPEN Pen)
{
  int i;
  SelectObject(hdc, Pen);
  for(i=1;i<5;++i)
    Circle(hdc, Polus, Point.x/i/30*Bv.x);
}

#pragma argsused
LONG ExceptionFilter(EXCEPTION_POINTERS *ExceptionInfo)
{
  DebugBreak();
  Error1=1;
  return EXCEPTION_CONTINUE_EXECUTION;
}

PT Norm(PT Pt)
{
  PT P1=Pt;
  while(P1.x>1000000000 || P1.y>1000000000 || P1.x<-1000000000 || P1.y<-1000000000)
  {
    P1.x=P1.x/2;
    P1.y=P1.y/2;
  }
  return P1;
}

void Free()
{
  FilledFlag=0;
}

void Fill()
{
  FilledFlag=1;
}

LRESULT FAR PASCAL Graph(HWND hwnd,UINT message,UINT wParam,LONG lParam)
{
  int i,j;
  if(message!=WM_CREATE)
    for(i=0;i<GraphWindowNum;++i)
      if(GraphWindow[i].hwnd==hwnd)
        break;
      else;
  else
  {
    for(i=0;i<GraphWindowNum;++i)
      if(GraphWindow[i].hwnd==NULL)
        break;
    GraphWindow[i].hwnd=hwnd;
  }
  switch (message)
  {
    case WM_CREATE:
      GraphWindow[i].B.x=1;
      GraphWindow[i].B.y=1;
      ShowWindow(hwnd,SW_SHOW);
      break;
    case WM_DESTROY:
      --GraphWindow[i].GraphPos[0];
      GlobalFree(GraphWindow[i].Point);
      GraphWindow[i].hwnd=NULL;
      for(j=i;j<GraphWindowNum-1;++j)
        GraphWindow[j]=GraphWindow[j+1];
      break;
    case WM_PAINT:
      MsgGraphPaint(hwnd,(HDC)wParam,&GraphWindow[i]);
      break;
    case WM_CHAR:
      if(wParam==0x2b)
      {
        GraphWindow[i].B.y=GraphWindow[i].B.y*2;
        RedrawWindow(hwnd,NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
      }
      if(wParam==0x2d)
      {
        GraphWindow[i].B.y=GraphWindow[i].B.y/2;
        RedrawWindow(hwnd,NULL,NULL,RDW_INVALIDATE | RDW_UPDATENOW);
      }
      break;
    default:
      return (DefWindowProc(hwnd, message, wParam, lParam));
  }
  return 0;
}

LRESULT MsgGraphPaint(HWND hwnd, HDC hdc, GRPH *GraphWindow)
{
    PAINTSTRUCT ps;

    BeginPaint(hwnd, &ps);
    DrawGraph(hwnd, ps.hdc, GraphWindow);
    EndPaint(hwnd, &ps);
    return 0;
}

void DrawGraph(HWND hwnd, HDC hdc, GRPH *GraphWindow)
{
    RECT  rcClient;        // size of client area
    double x1,y1,f1,dp,tmp1;
    char str[0x100];
    int i;
    PT B;

    GetClientRect(hwnd, &rcClient);
    FillRect(hdc,&rcClient,(HBRUSH)(COLOR_WINDOW + 1));
     xmax=rcClient.right;
     ymax=rcClient.bottom;

    BB=GraphWindow->B;
    BB.x=(double)xmax/GraphWindow->PointNum;

//     B.x= xmax/Len.x;
//     B.y= ymax/Len.y;
//     x_0=Min.x*B.x;
//     y_0=Max.y*B.y;

    x_0=0;
    y_0=ymax/2;

    Len.x=360;
    Len.y=ymax/BB.y;
    Min.x=fi0/M_PI*180;
    Min.y=(-y_0)/BB.y;
    Max.x=Min.x+Len.x;
    Max.y=(ymax-y_0)/BB.y;

    Grid(hdc);

    for(i=0;i<GraphWindow->PointNum-1;++i)
    {
      PT P1,P2;
      P1.x=i;
      P2.x=(i+1);
      P1.y=GraphWindow->Point[i].y;
      P2.y=GraphWindow->Point[i+1].y;
      Line(hdc, P1, P2, Green0);
      P1.y=GraphWindow->Point[i].x;
      P2.y=GraphWindow->Point[i+1].x;
      Line(hdc, P1, P2, Blue);
    }
}

void Grid(HDC hdc)
{
  PT Step,Point1,Point2;
  double x,y;
  char str[0x100];

  UINT OldAllign=SetTextAlign(hdc,TA_BOTTOM | TA_LEFT);

  Step.x=Len.x/5;
  Step.y=Len.y/5;
  for(x=0;x<Max.x;x+=Step.x)
  {
    Point2.x=Point1.x=x;
    Point1.y=Min.y;
    Point2.y=Max.y;
    Line(hdc,Point1,Point2,Green0);
    sprintf(str,"%.3f",x+fi0/M_PI*180);
    ZerroTruncate(str);
    if(x!=0)
      if(x+Step.x<Max.x)
        SetTextAlign(hdc,TA_BOTTOM | TA_CENTER);
      else
        SetTextAlign(hdc,TA_BOTTOM | TA_RIGHT);
    TextOut(hdc,X2Scr(x),ymax,str,lstrlen(str));
  }
  
  SetTextAlign(hdc,TA_BASELINE | TA_LEFT);

  for(y=0;y<Max.y;y+=Step.y)
  {
    Point2.y=Point1.y=y;
    Point1.x=0;
    Point2.x=Max.x;
    Line(hdc,Point1,Point2,Green0);
    sprintf(str,"%.3f",y);
    ZerroTruncate(str);
    TextOut(hdc,0,Y2Scr(y),str,lstrlen(str));
  }
  for(y=0;y>Min.y;y-=Step.y)
  {
    Point2.y=Point1.y=y;
    Point1.x=0;
    Point2.x=Max.x;
    if(y!=0)
      Line(hdc,Point1,Point2,Green0);
    else
      Line(hdc,Point1,Point2,Green);
    sprintf(str,"%.3f",y);
    ZerroTruncate(str);
    TextOut(hdc,0,Y2Scr(y),str,lstrlen(str));
  }

  COLORREF OldColor=SetTextColor(hdc,RGB(200,0,0));
  SetTextAlign(hdc,TA_BOTTOM | TA_RIGHT);
  TextOut(hdc,xmax,ymax-15," fi",7);
  SetTextColor(hdc,OldColor);

  SetTextAlign(hdc,OldAllign);
}

int X2Scr(double x)
{
  return x_0+x*BB.x;
}
int Y2Scr(double y)
{
  return y_0-y*BB.y;
}

void Text(HDC hdc, PT Polus, COLORREF Color, UINT Allign, char *str)
{
  UINT OldAllign;
  COLORREF OldColor;

  if(Color!=-1)
    OldColor=SetTextColor(hdc,Color);
  if(Allign!=-1)
    OldAllign=SetTextAlign(hdc,Allign);
  TextOut(hdc,X2Scr(Polus.x),Y2Scr(Polus.y),str,lstrlen(str));
  if(Allign!=-1)
    SetTextAlign(hdc,OldAllign);
  if(Color!=-1)
    SetTextColor(hdc,OldColor);
}
